using FluentValidation;
using CMSMicroservice.Protobuf.Protos.UserContract;
namespace CMSMicroservice.Protobuf.Validator.UserContract;

public class GetAllUserContractByFilterRequestValidator : AbstractValidator<GetAllUserContractByFilterRequest>
{
    public GetAllUserContractByFilterRequestValidator()
    {
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetAllUserContractByFilterRequest>.CreateWithOptions((GetAllUserContractByFilterRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
